MODULE out_mod
!
CONTAINS
!
SUBROUTINE input( atom )
REAL   , DIMENSION(4), INTENT(OUT)   :: atom
!
WRITE(*,*)
WRITE(*,1000,ADVANCE='NO') 
READ (*,*) atom(1:3)
atom(4) = 1.0
!
1000 FORMAT(' Give atom coordinates ')
END SUBROUTINE input
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
SUBROUTINE output(result, matrix, source)
!
IMPLICIT NONE
!
REAL, DIMENSION(:  ), INTENT(IN) :: result
REAL, DIMENSION(:,:), INTENT(IN) :: matrix
REAL, DIMENSION(:  ), INTENT(IN) :: source
CHARACTER(LEN=3), DIMENSION(3) :: spacer = (/'   ',' = ','   '/)
!
INTEGER   :: i,j
!
WRITE(*,*)
DO i=1,3
  WRITE(*,1000) result(i),spacer(i), (matrix(i,j),j=1,4), source(i)
ENDDO
WRITE(*,*)
!
1000 FORMAT(' (',F6.3,')',A3,'(',3(F8.3,','),F8.3,')(',F8.3,')')
END SUBROUTINE output
END MODULE out_mod
!
!
PROGRAM simple
!
USE out_mod
IMPLICIT NONE
!
INTEGER   :: i,k
REAL, DIMENSION(4,4) :: matrix = RESHAPE((/ 0.0, 1.0, 0.0, 0.0, &
                                           -1.0, 0.0, 0.0, 0.0, &
                                            0.0, 0.0, 1.0, 0.0, &
                                            0.0, 0.0, 0.0, 1.0  /), SHAPE(matrix))
REAL, DIMENSION(4)   :: source = (/1.00, 2.02, 3.003 , 1.00/)
REAL, DIMENSION(4)   :: result = 0.0
!
CALL input(source)
result = 0.0
result = MATMUL(matrix,source)
CALL output(result, matrix, source)
!
!
END PROGRAM SIMPLE
