MODULE home_3_mod
!
CONTAINS
!
SUBROUTINE input( atom )        ! Read one atom from keyboard
REAL   , DIMENSION(4), INTENT(OUT)   :: atom  ! Array for all atoms
!
WRITE(*,*   )                           ! Write a header
WRITE(*,1000,ADVANCE='NO')                    ! Prompt for input
READ (*,*) atom(1:3)                          ! Read into atom no. 1
atom(4) = 1.0                                 ! Set augmented element
!
1000 FORMAT(' Give atom coordinates ')
END SUBROUTINE input
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
LOGICAL FUNCTION equal(old, new)  ! Compare old and new atom positions for equality
!
IMPLICIT NONE
!
REAL   , DIMENSION(4,1), INTENT(IN) :: old
REAL   , DIMENSION(4,1), INTENT(IN) :: new
!
REAL, PARAMETER :: EPS = 1.E-6        ! Define an accuracy for equal positions
INTEGER :: i
!
equal = .true.                        ! Assume two atoms are on equal positions 
DO i = 1,3
   equal = equal .AND. ABS( old(i,1) - new(i,1)) < EPS ! false if atom coordinate deviate
END DO
!
END FUNCTION equal
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
SUBROUTINE printatom(atom, natom)  ! Print all atom position
!
IMPLICIT NONE
!
INTEGER                    , INTENT(IN) :: natom
REAL   , DIMENSION(4,natom), INTENT(IN) :: atom
!
INTEGER                :: iatom, i,j
!
WRITE(*,1000)                           ! Write a header
loop_atom: DO iatom = 1, natom          ! Loop over actual number of atoms
   WRITE(*,2000) iatom, (atom(i,iatom), i=1,3)
END DO loop_atom
write(*,*)                              ! Add one empty line
!
1000 FORMAT(/,'Atoms by 4 1/4, 1/4, z',/)
2000 FORMAT(' Atom No :', I4,2x, 3(F8.3,:', '))
END SUBROUTINE printatom
!
END MODULE home_3_mod
!
!
PROGRAM simple
!
USE home_3_mod
IMPLICIT NONE
!
INTEGER   :: i,j
REAL, DIMENSION(4,4) :: matrix = RESHAPE((/ 0.00, 1.00, 0.00, 0.00, &
                                           -1.00, 0.00, 0.00, 0.00, &
                                            0.00, 0.00, 1.00, 0.00, &
                                            0.50, 0.00, 0.00, 1.00  /), SHAPE(matrix))
REAL, DIMENSION(4  ) :: source = (/1.00, 2.02, 3.003 , 1.00/)
REAL, DIMENSION(4,4) :: result = 0.0
INTEGER              :: natom
!
CALL input(source)                         ! Get 1st atom position
result(:,1) = source                       ! Copy as first result
natom       = 1                            ! We now have 1 atom
power: DO i = 1,3                          ! Quick dirty, works for 4-fold only
   result(:,i+1) = MATMUL(matrix,source)   ! calculate new position
   DO j=1,natom                            ! Compare to all previous positions
      IF(equal(result(:,i+1), result(:,j))) THEN
         CYCLE power                       ! Atoms are identical go to next rotation
      ENDIF
   ENDDO
   source        = result(:,i+1)           ! New atom, copy back to source
   natom         = natom + 1               ! Update no of atoms
END DO power
CALL printatom(result, natom)              ! Print results
!
!
END PROGRAM SIMPLE
